/***************************************************************************
 *   Copyright (C) 2006 by M.Fedotov   *
 *   mo_fedotov@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef AR_CMDS_H
#define AR_CMDS_H

#include "ar_parser.h"

#define PARAM_START     "$("
#define PARAM_CALLID    "CallId)"
#define PARAM_TIME      "Time)"
#define PARAM_MODE      "Mode)"
#define PARAM_PARAM     "Param)"
#define PARAM_INDEX     "Index)"

#define SEND_STRING     "string"
#define SEND_BYTES      "bytes"

#define SET_ICONS     	"icons"
#define SET_TITLE     	"title"
#define SET_STATUS  	"status"
#define SET_TEXT      	"text"
#define SET_FG          "fg"
#define SET_BG          "bg"
#define SET_FONT        "font"
#define SET_VIBRATE     "vibrate"
#define SET_LIST        "list"
#define SET_SKIN        "skin"
#define SET_DEBUG       "debug"

/**
	@author M.Fedotov <mo_fedotov@mail.ru>
*/
class AR_Cmds {

public:
	AR_Cmds();
	~AR_Cmds();

	int handleCmdByKey	(type_key *tk, cmdParams *params);
	int  processCommands	(cmdItem* cmdList, cmdParams *p);
	void setStyle		(bool isServer);

	void freeTimers         (void);
	int  verifyTimers       (int ticksInSec);
	int  cancelTimer        (QString& id);
	int  processTimerCmd    (QString& origCmd);
	void setRemoteOn	(bool set);
	bool isRemoteOn	    	(void);

private:
	int execCmd   		(int type, QString& command, cmdParams *params);
	int execSimpleCmd	(QString command, int toFile, cmdParams *params);
	int execInFork  	(const char *cmd);
	int processSendCmd	(QString& origCmd);
	QString readResultsFile (void);  
	int execCmdAndGetResults(int type, QString commandOrig, timerCmd *tm, cmdParams *params);
	void sendData		(int type, QString& tag, QString data) ;
	timerCmd* findTimer	(QString& id, timerCmd **prev);
	int createTimer   	(QString& id, int type, float tmout, int times, QString cmd);
	void updateTimerLastData(timerCmd* timer, QString& data);
	
	int 		isServerMode;
	int 		remoteOn;
	timerCmd* 	timers;
};

#endif
