/***************************************************************************
 *   Copyright (C) 2006 by M.Fedotov   *
 *   mo_fedotov@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stream.h>

#include "kanyremote.h"
#include <kuniqueapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>

#include <kanyremote.h>

static const char description[] =
    I18N_NOOP("A KDE KPart Application");

static const char version[] = "2.3";

static KCmdLineOptions options[] =
{
	{ "f ",     	I18N_NOOP( "specify conf. file" ), 0 },
	{ "log", 	I18N_NOOP( "print logging info" ), 0 },
	{ "serial ", 	I18N_NOOP( "specify device to connect" ), 0 },

    KCmdLineLastOption
};

KAnyRemote  	    *mainWin 	= NULL;
KUniqueApplication  *pApp   	= NULL;

bool	printLog	= false;
QString	serial;
QString cfgFile;

int main(int argc, char **argv)
{
    KAboutData about("kanyremote", I18N_NOOP("KAnyRemote"), version, description,
                     KAboutData::License_GPL, "(C) 2006 M.Fedotov", 0, 0, "mo_fedotov@mail.ru");
    about.addAuthor( "M.Fedotov", 0, "mo_fedotov@mail.ru" );
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions( options );
    KUniqueApplication app;
    pApp = &app;

    if (app.isRestored())
    {
        RESTORE(KAnyRemote);
    }
    else
    {
        // no session.. just start up normally
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

        /// @todo do something with the command line args here
    	if (args->isSet("log")) {
	    printLog = true;
    	}
    	if (args->isSet("serial")) {
	    QCString srl = args->getOption("serial");
	    serial 	 = srl.data();
    	} 
    	if (args->isSet("f")) {
	    QCString ff	= args->getOption("f");
	    cfgFile 	= ff.data();
    	}

        mainWin = new KAnyRemote();
        app.setMainWidget( mainWin );

        args->clear();
    }

    // mainWin has WDestructiveClose flag by default, so it will delete itself.
    return app.exec();
}

